# Copyright 2007, TIG                                                         
# Permission to use, copy, modify, and distribute this software for           
# any purpose and without fee is hereby granted, provided that the above      
# copyright notice appear in all copies.                                      
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# Name :        RandomSelect.rb
# Description : Randomly selects entities in a selection.
# Use :         Select some entities and pick tool off menu.
#				Set % to be selected in dialog.
#				You can now colour, cut, copy, move etc the random selection...
# Version :		20080228 First Issue
require 'sketchup.rb'
def randomSelect
  model=Sketchup.active_model; ss=model.selection
  (UI.messagebox("No Selection !"); return nil) if ! ss[0]
  model.start_operation "Random Select"
  $rs_per=10.0 if not $rs_per
  rd_per,=inputbox(["% to remain Selected: "],[$rs_per],"Random Select")
  return nil if not rd_per; $rs_per=rd_per
  ###$rs_per=1.0 if $rs_per <1.0; $rs_per=99.0 if $rs_per >99.0###ranges
  ssa=ss.to_a; ss.clear
  ssa.each{|e|ss.add(e) if e.valid? && $rs_per >= rand*100}
  model.commit_operation
end
is_me=__FILE__
UI.menu("Plugins").add_item("Random Select"){randomSelect} if not file_loaded?(is_me)
file_loaded(is_me)
